#include <mysql/mysql.h>
#include "stralloc.h"
#ifndef O_NOT_LOG_SQL
#include "qsutil.h"
#endif

extern MYSQL dbh, *mysql;
extern MYSQL_RES *result;

/* run a given query and return 1 row only */
MYSQL_ROW do_query(stralloc *query) {
  int num;
#ifndef O_NOT_LOG_SQL
  int i;
  char *x;
  stralloc showme = { 0 };
#endif

  if (! connect_mysql()) return -1;
#ifndef O_NOT_LOG_SQL
  if (! stralloc_ready(&showme, query->a)) goto carryon;
  num = i = 0;
  for (x = query->s; num < 2; x++) {
    if (*x == '(' || *x == ')') num++;
    if (! num) i++;
  }
  if (! stralloc_catb(&showme, query->s, i)) goto carryon;
  if (! stralloc_cats(&showme, x)) goto carryon;
  if (! stralloc_0(&showme)) goto carryon;
  log3("query: ", showme.s, ";\n");
carryon:
#endif
  if (mysql_real_query(mysql, query->s, query->len) < 0) {
    log3("error: ", mysql_error(&dbh), "\n");
    return -1;
  }
  if (! (result = mysql_store_result(mysql))) return -1;

  num = mysql_num_rows(result);

  if (num != 1) {
    mysql_free_result(result);
    return 0;
  }

  return mysql_fetch_row(result);
}

